import random
import time
import matplotlib.pyplot as plt
from statistics import mean

points = list(range(10, 40))
repetition = 10
resultats = []

def commence(s, t):
	""" Retourne True si s commence par t """
	q = len(t)
	if len(s) < q:
		return False
	for i in range(q):
		if s[i] != t[i]:
			return False
	return True

def commence2(u, v):
	return u[:len(v)] == v

def sous_chaine1(u, v):
	n = len(u)
	for i in range(n):
		if commence(u[i:], v):
			return i
	return None

def sous_chaine2(u, v):
	n = len(u)
	for i in range(n):
		if commence2(u[i:], v):
			return i
	return None

def sous_chaine3(u, v):
	try:
		return u.index(v)
	except ValueError:
		return None


if __name__ == "__main__":
	fcts = [sous_chaine1, sous_chaine2, sous_chaine3]
	plt.xlabel("n")
	plt.title("Temps d'exécution des fonctions sous_chaine")

	points = 100
	degree = 2 
	repetition = 50
	fig, axs = plt.subplots(1, len(fcts), constrained_layout=True)
	colors = plt.rcParams["axes.prop_cycle"]()

	for i, f in enumerate(fcts):
		resultats = []
		ax = axs[i]
		exit = False
		for i in range(1, points):
			i = int(i**degree)
			u = "a"*(2*i)
			v = "a"*i + "b"
			temps_calculs = []
			resultats.append(temps_calculs)
			for _ in range(repetition):
				init_time = time.time_ns()
				_ = f(u, v)
				stop_time = time.time_ns()
				temps_calculs.append(stop_time - init_time)
				if (stop_time - init_time) > 4000000:
					exit = True
					break
			if exit:
				break
		ax.plot(
			[i**degree for i in range(1, len(resultats) + 1)],
			[mean(x)/10**3 for x in resultats],
			marker=".",
			label=f.__name__,
			color=next(colors)["color"]
			)
		ax.set_ylabel("Temps (en µs)")
		ax.set_xlabel("Taille des mots (n)")
		ax.legend()
	plt.savefig("sous_chaines.png")
